/* 
Copyright (C) 1995-2001 Activision, Inc.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/* Two-letter language codes from ISO 639; see 
 * http://www.perl.com/CPAN-local/modules/by-module/Locale/Locale-Codes-0.003.tar.gz
 * Numerical values are assigned here for the few we actually use.
 */
#define dp_LANGNUM_en  1	/* English */
#define dp_LANGNUM_de  2	/* German */
#define dp_LANGNUM_fr  4	/* French */
#define dp_LANGNUM_es  8	/* Spanish */
#define dp_LANGNUM_it 16	/* Italian */
#define dp_LANGNUM_pt 32	/* Portuguese */
#define dp_LANGNUM_ja 64	/* Japanese */
#define dp_LANGNUM_uk 128	/* UK (british english) - kludge */

#define dp_LANGNAME_aa "Afar"
#define dp_LANGNAME_ab "Abkhazian"
#define dp_LANGNAME_af "Afrikaans"
#define dp_LANGNAME_am "Amharic"
#define dp_LANGNAME_ar "Arabic"
#define dp_LANGNAME_as "Assamese"
#define dp_LANGNAME_ay "Aymara"
#define dp_LANGNAME_az "Azerbaijani"

#define dp_LANGNAME_ba "Bashkir"
#define dp_LANGNAME_be "Byelorussian"
#define dp_LANGNAME_bg "Bulgarian"
#define dp_LANGNAME_bh "Bihari"
#define dp_LANGNAME_bi "Bislama"
#define dp_LANGNAME_bn "Bengali; Bangla"
#define dp_LANGNAME_bo "Tibetan"
#define dp_LANGNAME_br "Breton"

#define dp_LANGNAME_ca "Catalan"
#define dp_LANGNAME_co "Corsican"
#define dp_LANGNAME_cs "Czech"
#define dp_LANGNAME_cy "Welsh"

#define dp_LANGNAME_da "Danish"
#define dp_LANGNAME_de "German"
#define dp_LANGNAME_dz "Bhutani"

#define dp_LANGNAME_el "Greek"
#define dp_LANGNAME_en "English"
#define dp_LANGNAME_eo "Esperanto"
#define dp_LANGNAME_es "Spanish"
#define dp_LANGNAME_et "Estonian"
#define dp_LANGNAME_eu "Basque"

#define dp_LANGNAME_fa "Persian"
#define dp_LANGNAME_fi "Finnish"
#define dp_LANGNAME_fj "Fiji"
#define dp_LANGNAME_fo "Faeroese"
#define dp_LANGNAME_fr "French"
#define dp_LANGNAME_fy "Frisian"

#define dp_LANGNAME_ga "Irish"
#define dp_LANGNAME_gd "Scots Gaelic"
#define dp_LANGNAME_gl "Galician"
#define dp_LANGNAME_gn "Guarani"
#define dp_LANGNAME_gu "Gujarati"

#define dp_LANGNAME_ha "Hausa"
#define dp_LANGNAME_hi "Hindi"
#define dp_LANGNAME_hr "Croatian"
#define dp_LANGNAME_hu "Hungarian"
#define dp_LANGNAME_hy "Armenian"

#define dp_LANGNAME_ia "Interlingua"
#define dp_LANGNAME_ie "Interlingue"
#define dp_LANGNAME_ik "Inupiak"
#define dp_LANGNAME_in "Indonesian"
#define dp_LANGNAME_is "Icelandic"
#define dp_LANGNAME_it "Italian"
#define dp_LANGNAME_iw "Hebrew"

#define dp_LANGNAME_ja "Japanese"
#define dp_LANGNAME_ji "Yiddish"
#define dp_LANGNAME_jw "Javanese"

#define dp_LANGNAME_ka "Georgian"
#define dp_LANGNAME_kk "Kazakh"
#define dp_LANGNAME_kl "Greenlandic"
#define dp_LANGNAME_km "Cambodian"
#define dp_LANGNAME_kn "Kannada"
#define dp_LANGNAME_ko "Korean"
#define dp_LANGNAME_ks "Kashmiri"
#define dp_LANGNAME_ku "Kurdish"
#define dp_LANGNAME_ky "Kirghiz"

#define dp_LANGNAME_la "Latin"
#define dp_LANGNAME_ln "Lingala"
#define dp_LANGNAME_lo "Laothian"
#define dp_LANGNAME_lt "Lithuanian"
#define dp_LANGNAME_lv "Latvian, Lettish"

#define dp_LANGNAME_mg "Malagasy"
#define dp_LANGNAME_mi "Maori"
#define dp_LANGNAME_mk "Macedonian"
#define dp_LANGNAME_ml "Malayalam"
#define dp_LANGNAME_mn "Mongolian"
#define dp_LANGNAME_mo "Moldavian"
#define dp_LANGNAME_mr "Marathi"
#define dp_LANGNAME_ms "Malay"
#define dp_LANGNAME_mt "Maltese"
#define dp_LANGNAME_my "Burmese"

#define dp_LANGNAME_na "Nauru"
#define dp_LANGNAME_ne "Nepali"
#define dp_LANGNAME_nl "Dutch"
#define dp_LANGNAME_no "Norwegian"

#define dp_LANGNAME_oc "Occitan"
#define dp_LANGNAME_om "(Afan) Oromo"
#define dp_LANGNAME_or "Oriya"

#define dp_LANGNAME_pa "Punjabi"
#define dp_LANGNAME_pl "Polish"
#define dp_LANGNAME_ps "Pashto, Pushto"
#define dp_LANGNAME_pt "Portuguese"

#define dp_LANGNAME_qu "Quechua"

#define dp_LANGNAME_rm "Rhaeto-Romance"
#define dp_LANGNAME_rn "Kirundi"
#define dp_LANGNAME_ro "Romanian"
#define dp_LANGNAME_ru "Russian"
#define dp_LANGNAME_rw "Kinyarwanda"

#define dp_LANGNAME_sa "Sanskrit"
#define dp_LANGNAME_sd "Sindhi"
#define dp_LANGNAME_sg "Sangro"
#define dp_LANGNAME_sh "Serbo-Croatian"
#define dp_LANGNAME_si "Singhalese"
#define dp_LANGNAME_sk "Slovak"
#define dp_LANGNAME_sl "Slovenian"
#define dp_LANGNAME_sm "Samoan"
#define dp_LANGNAME_sn "Shona"
#define dp_LANGNAME_so "Somali"
#define dp_LANGNAME_sq "Albanian"
#define dp_LANGNAME_sr "Serbian"
#define dp_LANGNAME_ss "Siswati"
#define dp_LANGNAME_st "Sesotho"
#define dp_LANGNAME_su "Sundanese"
#define dp_LANGNAME_sv "Swedish"
#define dp_LANGNAME_sw "Swahili"

#define dp_LANGNAME_ta "Tamil"
#define dp_LANGNAME_te "Tegulu"
#define dp_LANGNAME_tg "Tajik"
#define dp_LANGNAME_th "Thai"
#define dp_LANGNAME_ti "Tigrinya"
#define dp_LANGNAME_tk "Turkmen"
#define dp_LANGNAME_tl "Tagalog"
#define dp_LANGNAME_tn "Setswana"
#define dp_LANGNAME_to "Tonga"
#define dp_LANGNAME_tr "Turkish"
#define dp_LANGNAME_ts "Tsonga"
#define dp_LANGNAME_tt "Tatar"
#define dp_LANGNAME_tw "Twi"

#define dp_LANGNAME_uk "Ukrainian"
#define dp_LANGNAME_ur "Urdu"
#define dp_LANGNAME_uz "Uzbek"

#define dp_LANGNAME_vi "Vietnamese"
#define dp_LANGNAME_vo "Volapuk"

#define dp_LANGNAME_wo "Wolof"

#define dp_LANGNAME_xh "Xhosa"

#define dp_LANGNAME_yo "Yoruba"

#define dp_LANGNAME_zh "Chinese"
#define dp_LANGNAME_zu "Zulu"

